Index: trunk/doc/CHANGES.OS2
===================================================================
--- trunk/doc/CHANGES.OS2	(revision 263)
+++ trunk/doc/CHANGES.OS2	(revision 266)
@@ -6,12 +6,34 @@
 
 
-1.6.0 Build 19 XXX (2011-xx-xx)
+1.6.0 Build 19 RC (2011-02-21)
+
+  - Ported and enabled the JPDA (Java Platform Debugger Architecture) component
+    which provides a framework for debugging Java applications.
+
+  - Added sound (audio and MIDI) support to Java applications using DART.
+
+  - Added a free implementation of the com.sun.image.codec.jpeg package (taken
+    from the IcedTea project) used by some old Java applications like Jeti/2.
+
+  - Renamed all Java DLLs by adding a 'j' prefix to the names to avoid possible
+    conflicts with system DLLs.
 
   - Fixed: Accessing the network from Java applications would crash on some
     machines (Odin bug).
 
-  - Fixed: spontaneous 100% CPU load in many Java applications (e.g. GenealogyJ
+  - Fixed: Spontaneous 100% CPU load in many Java applications (e.g. GenealogyJ
     Jeti/2) when throwing NullPointerException as a result of accessing null
     objects of some application classes (Odin bug).
+
+  - Fixed: java.util.prefs.Preferences: Use the Open32 registry on OS/2 instead
+    of throwing an exception.
+
+  - Fixed: JVM used PATH instead of LIBPATH to comprise java.library.path
+    resulting in inability to find JNI DLLs in some applications.
+
+  - Fixed: Crash in java.io.WinNTFileSystem.getSpace() (Odin bug).
+
+  - Fixed: Exception java.awt.image.ImagingOpException in many applications due
+    to wrong exports from in jmlibimg.dll.
 
 
Index: trunk/doc/README.OS2
===================================================================
--- trunk/doc/README.OS2	(revision 263)
+++ trunk/doc/README.OS2	(revision 266)
@@ -1,5 +1,5 @@
 OpenJDK 6 for OS/2 and eCS
 
-Version 1.6.0 Build 19 RC (2011-xx-yy)
+Version 1.6.0 Build 19 RC (2011-02-21)
 
 This is a release candidate build intended for testing purposes.
@@ -28,7 +28,7 @@
   - A OS/2 Warp 4 Fixpack 16+, OS/2 Warp 4.5 or eComStation operating system.
 
-  - Odin32 library version 0.6.21558 (2011-01-12) or above:
-
-    ftp://ftp.netlabs.org/pub/odin/odin32bin-20110112-release.wpi
+  - Odin32 library version 0.6.21577 (2011-02-21) or above:
+
+    ftp://ftp.netlabs.org/pub/odin/odin32bin-20110221-release.wpi
 
 
@@ -221,13 +221,21 @@
 
   Besides adding the 'j' prefix, some DLLs were also renamed further to fit the
-  8 character length limit forced by the OS/2 kernel loader.
-
-
-  On OS/2, the directory containing JDK DLLs
-  In order to avoid conflicts...
-  the following dlls were renamed...
-
-  hprof.dll -> jhprof.dll in -agentlib: cmd line option
-  debug dlls as well
+  8 character DLL name length limit forced by the OS/2 kernel loader.
+
+  This rename operation is transparent to all Java applications except a few
+  cases which involve custom agent libraries used to enhance the functionality
+  of JDK or JVM. These libraries in particular include:
+
+  Original Name            New Name
+  --------------------------------------------
+  hprof.dll                jhprof.dll
+  dt_shmem.dll             jdtshmem.dll
+  dt_socket.dll            jdtsock.dll
+
+  In order to use the renamed libraries, you need to substitute the old name
+  with the new name wherever the old name is used in Java documentation,
+  configuration files or command line options. For example, to use the profiler
+  library, you will have to write "-agentlib:jhprof.dll" on the command line
+  instead of "-agentlib:hprof.dll" and so on.
 
 
@@ -240,11 +248,6 @@
      Warp4 kernel instead.
 
-  2. The JPDA (Java Platform Debugger Architecture) component is missing.
-
-  3. The com.sun.tools.attach package (API to attach to a Java virtual machine)
+  2. The com.sun.tools.attach package (API to attach to a Java virtual machine)
      is missing.
-
-  4. Some other rarely used Java system classes may also be missing in this
-     release.
 
   See the project roadmap for more information on the current progress and